HDU 1394 Minimum Inversion Number (线段树,单点更新)

C - Minimum Inversion Number

Crawling in process... Crawling failed Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u

Submit Status Practice HDU 1394

Appoint description:
System Crawler (2015-08-17)

Description

The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj.

For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seqence, we will obtain another sequence. There are totally n such sequences as the following:

a1, a2, ..., an-1, an (where m = 0 - the initial seqence)
a2, a3, ..., an, a1 (where m = 1)
a3, a4, ..., an, a1, a2 (where m = 2)
...
an, a1, a2, ..., an-1 (where m = n-1)

You are asked to write a program to find the minimum inversion number out of the above sequences.

Input

The input consists of a number of test cases. Each case consists of two lines: the first line contains a positive integer n (n <= 5000); the next line contains a permutation of the n integers from 0 to n-1.

Output

For each case, output the minimum inversion number on a single line.

Sample Input

10
1 3 6 9 0 8 5 7 4 2

Sample Output

16

题目大意:

  这道题是说,给你一个长度为n的排列(由0到n-1组成),每次可以把第一个元素放到最后面,那么就会产生逆序数,一个排列的逆序数等于的是这个排列中的所有数字的逆序数的和。

那么,这道题,可以用线段树来解决,我们首先建立一个空树,也就是说,这个树中的每个节点的sum==0,表示全0,然后,我们每次插入一个数字,就在这个数字的对应位置放一个1,

也就是按照权值来建立这棵线段树,线段树最下面一层的叶子节点所维护的权值就是0~n-1。每次插入一个数字后,只要统计有多少个数字比这刚刚插入的这个数字大就可以了。

然后我们知道,对于一个仅仅由0~n-1组成的排列,把第一个数字放到最后一位,所产生的贡献是,减少了a[i],增加了n-1-a[i]个。那么每次都算一遍贡献,直到找到那个最小的贡献就可以了。

代码:

# include<cstdio>
# include<iostream>

using namespace std;

# define MAX 5004
# define inf 99999999
# define lid id<<1
# define rid id<<1|1

struct Segtree
{
    int l,r;
    int sum;
}tree[MAX*4];
int a[MAX];

void push_up( int id )
{
    tree[id].sum = tree[lid].sum+tree[rid].sum;
}

void build ( int id,int l,int r )
{
    tree[id].l = l; tree[id].r = r;
    tree[id].sum = 0;
    if ( l==r )
    {
        return;
    }
    int mid = ( tree[id].l+tree[id].r )/2;
    build ( lid,l,mid);
    build ( rid,mid+1,r);
    push_up(id);
}

void update( int id,int x,int val )
{
    if ( tree[id].l==tree[id].r )
    {
        tree[id].sum = 1;
        return;
    }
    int mid = ( tree[id].l+tree[id].r )/2;
    if ( x<=mid )
        update(lid,x,val);
    else
        update(rid,x,val);
    push_up(id);
}

int query( int id,int l,int r )
{
    if ( tree[id].l==l&&tree[id].r==r )
    {
        return tree[id].sum;
    }
    int mid = ( tree[id].l+tree[id].r )/2;
    if ( r <= mid )
        return query(lid,l,r);
    else if ( l > mid )
        return query(rid,l,r);
    else
    {
        return query(lid,l,mid)+query(rid,mid+1,r);
    }
}

int main(void)
{
    int n;
    while ( scanf("%d",&n)!=EOF )
    {
        for ( int i = 0;i < n;i++ )
            scanf("%d",&a[i]);
        build(1,0,n-1);
        int sum = 0;
        for ( int i = 0;i < n;i++ )
        {
            if( a[i]!=n-1 )
            {
                sum+= query(1,a[i]+1,n-1);
                update(1,a[i],1);
            }
            else
            {
                sum+=query(1,a[i],n-1);
                update(1,a[i],1);
            }
        }
        int ans = inf;
        ans = min(ans,sum);
        for ( int i = 0;i < n;i++ )
        {
            sum-=a[i];
            sum+=n-1-a[i];
            ans = min(ans,sum);
        }
        printf("%d\n",ans);
    }

    return 0;
}

  

时间: 2024-10-23 08:33:50

HDU 1394 Minimum Inversion Number (线段树,单点更新)的相关文章

hdu 1394 Minimum Inversion Number 线段树 点更新

// hdu 1394 Minimum Inversion Number 线段树 点更新 // // 典型线段树的单点更新 // // 对于求逆序数,刚开始还真的是很年轻啊,裸的按照冒泡排序 // 求出最初始的逆序数,然后按照公式递推,结果就呵呵了 // // 发现大牛都是用线段树和树状数组之类的做的,而自己又在学 // 线段树,所以就敲了线段树. // // 线段树的节点保存一段区间( L,R )内0,1...n一共出现了多少个. // 因为每个数是0,1,2...n-1且没有重复的数字. /

HDU 1394 Minimum Inversion Number.(线段树)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1394 ~~~~ 早起一发线段树,开心又快乐.这题暴力也能水过,同时线段树的效率也就体现的尤为明显了,看了大牛的博客,说是还可以用树状数组,点树和合并序列写,现在还不懂,留着以后在写吧. ~~~~ 大致题意:给定一个数字序列,同时由此可以得到n个序列, 要求从n个序列中找到逆序数最小的序列,输出最小逆序数. 首先介绍下逆序数的概念: 在一个排列中,如果一对数的前后位置与大小顺序相反,即前面的数大于后面

Minimum Inversion Number(线段树单点更新+逆序数)

Minimum Inversion Number(线段树单点更新+逆序数) Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy

Hdu 1394 Minimum Inversion Number(线段树或树状数组)

Minimum Inversion Number Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 11981    Accepted Submission(s): 7321 Problem Description The inversion number of a given number sequence a1, a2, ..., a

HDU 1394 Minimum Inversion Number (线段树,暴力)

Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of the seq

hdu - 1394 Minimum Inversion Number(线段树水题)

http://acm.hdu.edu.cn/showproblem.php?pid=1394 很基础的线段树. 先查询在更新,如果后面的数比前面的数小肯定会查询到前面已经更新过的值,这时候返回的sum就是当前数的逆序数. 这样查询完之后得到初始数列的逆序数,要求得所有序列的最小逆序数,还需要循环一次. 设初始序列abcde中逆序数为k,小于a的个数是t-1那么大于a的个数就是n-t,当把a左移一位,原来比a大的都变成了a的逆序对,即逆序数增加了n-t,但是原来比a小的数都变成了顺序, 因此逆序数

hdu 1394 Minimum Inversion Number 线段树

Problem Description The inversion number of a given number sequence a1, a2, ..., an is the number of pairs (ai, aj) that satisfy i < j and ai > aj. For a given sequence of numbers a1, a2, ..., an, if we move the first m >= 0 numbers to the end of

hdu1394 Minimum Inversion Number(线段树单点更新||暴力)

题目链接: huangjing 这个题目暴力和线段树都可以过,但是都需要掌握一个规律.. 当队首元素移到队尾后,可定会减少a[i]个逆序对,然后增加n-1-a[i]个逆序对. 你看比如1移到队尾,那么1>0这个逆序对就会减少,2>1,3>1,4>1这些逆序对就会增加.. 所以发现这个规律就好做了.. 暴力做法就是直接那样模拟.. 线段树做法是首先建立一颗空树,然后插入之前询问这颗树中在[插入元素,n]之间的树,求出来的就是逆序对的个数.然后将其更新进去即可.. 题目: 寻人启事:2

hdu 1394 Minimum Inversion Number (裸树状数组 求逆序数)

题目链接 题意: 给一个n个数的序列a1, a2, ..., an ,这些数的范围是0-n-1, 可以把前面m个数移动到后面去,形成新序列:a1, a2, ..., an-1, an (where m = 0 - the initial seqence)a2, a3, ..., an, a1 (where m = 1)a3, a4, ..., an, a1, a2 (where m = 2)...an, a1, a2, ..., an-1 (where m = n-1)求这些序列中,逆序数最少的